#ifndef __DEMUX_HEADER_INCLUDED__
#define __DEMUX_HEADER_INCLUDED__

#include <g_globals.h>
#include <s_globals.h>
#include <lists.h>

/* demux_layer_from_plugins() returns this */
typedef enum demux_ret{
	DLFP_NOT_FOUND,	/* A suitable plugin wasn't found */
	DLFP_OK,		/* A plugin was found */
	DLFP_JUMP,	/* A plugin said skip the rest of the packet */
	DLFP_DROP,	/* A plugin told us to drop the packet !! */
	DLFP_ERROR	/* internal unspecified error */
}demux_ret_t;

/* plugins return this */
typedef enum demux_pret{
	DEMUX_NULL,	/* No joy, carry on */
	DEMUX_SKIP,	/* This layer finished, go to next */
	DEMUX_JUMP,	/* This packet complete, skip all further steps */
	DEMUX_DROP	/* Drop the packet dead (hmmm not good) */
}demux_pret_t;

/* Threaded capdevs call this, it demultiplexes all layers  */
network_layer_t demux( p_packet p );

/* Plugins register a bunch of these with us */
typedef demux_pret_t (*proc_demux)( p_packet p );

/* Plugins call this to add demux handlers  */
typedef uint (*proc_demux_add_handler) (uint, proc_demux);
uint demux_add_handler (uint layer, proc_demux target);

/* We maintain an array LAYERS_MAX of these lists*/
typedef struct demux_layer {
	list_head_t		l;
	proc_demux		demux;
}demux_layer_t, *p_demux_layer;

/* Init, plain and simple */
int demux_init(void);

#endif /* __DEMUX_HEADER_INCLUDED__ */
